set ATTRIBUTE;
set N_class := 1..3;
set N_candidate := 1 .. 15;
set CLASS1 := 1 .. 5;
set CLASS2 := 6 .. 10;
set CLASS3 := 11 .. 15;

param Weight {ATTRIBUTE}  >= 0;
param MIN {ATTRIBUTE} >= 0;
param MAX {j in ATTRIBUTE}  >= MIN [j];
param Posi_status {j in ATTRIBUTE} ;
param Com_status {j in ATTRIBUTE} ;
param QOS {N_candidate,ATTRIBUTE} >= 0;

var use {i in N_candidate} binary;

var ComService {k in N_class,j in ATTRIBUTE} =
	if k== 1 then sum {i in CLASS1} use[i]*QOS[i,j]
		else if k== 2 then sum {i in CLASS2} use[i]*QOS[i,j]
					else sum {i in CLASS3} use[i]*QOS[i,j];

var ComScore {j in ATTRIBUTE} =
	if Com_status[j]==1 then sum {i in N_class} ComService[i,j]
		else if Com_status[j]==2 then (prod {i in N_class} ComService[i,j])
			else if Com_status[j]==3 then min {i in N_class} ComService[i,j]
				else sum  {i in N_class} ComService[i,j] /5;

var UniComScore {j in ATTRIBUTE} =
	if Posi_status[j] == 1 then (ComScore[j] - MIN[j])/(MAX[j]-MIN[j])
		else  (MAX[j]-ComScore[j] )/(MAX[j]-MIN[j]);

maximize  ComSAW : sum{j in ATTRIBUTE} UniComScore[j]*Weight[j];

subject to Class1_num: sum {i in CLASS1} use[i]=1;
subject to Class2_num: sum {i in CLASS2} use[i]=1;
subject to Class3_num: sum {i in CLASS3} use[i]=1;

